local name, ns = ...

local playerID,guildID
local NUM_BAG_SLOTS = NUM_BAG_SLOTS
local GetContainerNumSlots = GetContainerNumSlots
local GetContainerItemLink = GetContainerItemLink
local GetContainerItemInfo = GetContainerItemInfo
local strsplit,format = strsplit,format
local resultStore = {}
local sync = {}
local BankIsOpen, GuildBankIsOpen = false, false
ns['defaults'] = {
	['profile'] = {
		['icons'] = {},
		['names'] = {},
		['currencies'] = {},
		['bags'] = {},
		['bank'] = {},
		['guildbank'] = {},
		['units'] = {},
		['guilds'] = {}
	}
}
ns['frame'] = CreateFrame("FRAME")
local function getPlayerID()
	if(playerID) then
		return playerID
	end
	local pname, pserver = UnitFullName("player")
	if(not pserver) then
		return
	end
	local player = format("%s - %s",pname,pserver)
	playerID = 0
	ns['db']['profile']['units'] = ns['db']['profile']['units'] or {}
	for k,v in pairs(ns['db']['profile']['units']) do
		if(v['name']==player) then
			playerID = k
			return playerID
		end
		if(k>=playerID) then
			playerID = k
		end
	end
	playerID = playerID + 1
	ns['db']['profile']['units'][playerID]= {
		['name'] = player,
		['faction'] = UnitFactionGroup('player')
	}
	return playerID
end
local function checkPID()
	if(not playerID) then
		playerID = getPlayerID()
	end
	if(playerID) then
		ns['db']['profile']['bags'][playerID] = ns['db']['profile']['bags'][playerID] or {}
		ns['db']['profile']['bank'][playerID] = ns['db']['profile']['bank'][playerID] or {}
		ns['db']['profile']['currencies'][playerID] = ns['db']['profile']['currencies'][playerID] or {}
		return true
	end
end
local function getGuildID()
	local guildName, description = GetGuildFactionInfo()
	local pname, pserver = UnitFullName("player")
	if(not pserver) then
		return
	end
	local guild = format("%s - %s",guildName,pserver)
	guildID = 0
	ns['db']['profile']['guilds'] = ns['db']['profile']['guilds'] or {}
	for k,v in pairs(ns['db']['profile']['guilds']) do
		if(v['name']==guild) then
			guildID = k
			return guildID
		end
		if(k>=guildID) then
			guildID = k
		end
	end
	guildID = guildID + 1
	ns['db']['profile']['guilds'][playerID]= {
		['name'] = guild,
		['faction'] = UnitFactionGroup('player')
	}
	return playerID	
end
local function checkGID()
	if(not guildID) then
		guildID = getGuildID()
	end
	if(guildID) then
		ns['db']['profile']['guildbank'][guildID] = ns['db']['profile']['guildbank'][guildID] or {}
		return true
	end
end
local function colorize(text,color)
	return string.format("|cff%s%s|r",color,text)
end
local function getCurrencyItem(index)
	local currencyLink = GetCurrencyListLink(index)
	if(currencyLink) then
		return currencyLink:match("currency:(%d+)") or nil
	end
end
local function updateCurrencies(playerID)
	if(checkPID()) then
		for index=1,GetCurrencyListSize() do
			local name, isHeader, isExpanded, isUnused, isWatched, count, icon, maximum, hasWeeklyLimit, currentWeeklyAmount =GetCurrencyListInfo(index)
			local itemID = getCurrencyItem(index)
			if((not isHeader) and itemID) then
				resultStore[itemID] = nil
				ns['db']['profile']['currencies'][playerID][itemID] = {
					['count'] = count,
					['max'] = maximum,
				}
				if(icon) then
					ns['db']['profile']['icons'][itemID] = "|T"..icon..":0|t"
				end
			end
		end
	end
end
ns['frame']['ADDON_LOADED'] = function(self,event,arg1)
	if(arg1 ~= name) then return end
	ns['db'] = LibStub("AceDB-3.0"):New(name .. "DB", ns['defaults'], true);
	self:UnregisterEvent("ADDON_LOADED")
	self:RegisterEvent("BAG_UPDATE")
	self:RegisterEvent("BAG_UPDATE_DELAYED")
	self:RegisterEvent("BANKFRAME_OPENED")
	self:RegisterEvent("BANKFRAME_CLOSED")
	self:RegisterEvent("PLAYERBANKBAGSLOTS_CHANGED")
	self:RegisterEvent("PLAYERBANKSLOTS_CHANGED")
	self:RegisterEvent("PLAYERREAGENTBANKSLOTS_CHANGED")
	self:RegisterEvent("GET_ITEM_INFO_RECEIVED")
	self:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
	self:RegisterEvent("ITEM_UNLOCKED")
	self:RegisterEvent("GUILDBANKBAGSLOTS_CHANGED")
	self:RegisterEvent("GUILDBANKFRAME_CLOSED")
	self:RegisterEvent("GUILDBANKFRAME_OPENED")
end
ns['frame']:HookScript("OnEvent", function(self, event, ...)
	if(type(self[event])=='function') then
		self[event](self,event,...)
	end
 end)
ns['frame']:RegisterEvent("ADDON_LOADED")
local function getItemId(link)
	if(link) then
		local _, _, itemString = string.find(link, "^|c%x+|H(.+)|h%[.*%]")
		local _,id,_ = strsplit(":",itemString)
		return id
	end
end
local function bagLoop(res,id,cName,depot)
	local name = nil
	local dName = cName
	for k,v in pairs(ns['db']['profile'][depot]) do
		if(ns['db']['profile']['units'][k]) then
			if(ns['db']['profile']['units'][k]['faction']==ns['db']['profile']['units'][playerID]['faction']) then
				name = ns['db']['profile']['units'][k]['name']
				for bag,list in pairs(v) do
					if(bag == -3) then
						dName = 'reagentCount'
					else
						dName = cName
					end
					for a,b in pairs(list) do
						if(a == id) then
							res[name] = res[name] or {
								[dName] = 0
							}
							res[name][dName] = res[name][dName] or 0
							res[name][dName] = res[name][dName] + b['count']
						end
					end
				end
			end
		end
	end
	return res
end
local function curLoop(res,id)
	local name = nil
	for k,v in pairs(ns['db']['profile']['currencies']) do
		if(ns['db']['profile']['units'][k]) then
			name = ns['db']['profile']['units'][k]['name']
			for a,b in pairs(v) do
				if(a == id and b['count']>0) then
					res[name] = b['count']
					if(b['max']>0) then
						res[name] = colorize(format("%s/%s",b['count'],b['max']),b['count']==b['max'] and "ff0000" or "ffffff")
					else
						res[name] = colorize(format("%s",b['count']),"ffffff")
					end
				end
			end
		end
	end
	return res
end
local function setName(id,itemname)
	if(id and itemname) then
		ns['db']['profile']['names'][id] = itemname
	end
end
local function getName(id)
	if(not ns['db']['profile']['names'][id]) then
		setName(id,GetItemInfo(id))
	end
	return ns['db']['profile']['names'][id]
end
local function getIcon(id)
	if(not ns['db']['profile']['icons'][id]) then
		local itemname, _, _, _, _, _, _, _, _, icon = GetItemInfo(id)
		setName(id,itemname)
		if(icon) then
			ns['db']['profile']['icons'][id] = "|T"..icon..":0|t"
		end
	end
	return ns['db']['profile']['icons'][id] or ''
end
local function getResult(id)
	if(resultStore[id]) then
		return resultStore[id]
	end
end
local function setResult(id,res)
	resultStore[id] = res
end
local function gbagLoop(res,id,cName,depot)
	local name = nil
	local dName = cName
	for k,v in pairs(ns['db']['profile'][depot]) do
		if(ns['db']['profile']['guilds'][k]) then
			if(ns['db']['profile']['guilds'][k]['faction']==ns['db']['profile']['guilds'][guildID]['faction']) then
				name = ns['db']['profile']['guilds'][k]['name']
				for bag,list in pairs(v) do
					for a,b in pairs(list) do
						if(a == id) then
							res[name] = res[name] or {
								[dName] = 0
							}
							res[name][dName] = res[name][dName] or 0
							res[name][dName] = res[name][dName] + b['count']
						end
					end
				end
			end
		end
	end
	return res
end
local function GameTooltip_OnTooltipSetItem(tooltip)
	local _, link = tooltip:GetItem()
	if(not link) then
		return
	end
	local id = getItemId(link)
	if(id)then
		tooltip:AddLine()
		local res = getResult(id)
		local isCurrency = link:match("currency:(%d+)")
		if(not res) then
			if(isCurrency) then
				res = curLoop({},isCurrency)
			else
				res = bagLoop({},id,'count','bags')
				res = bagLoop(res,id,'bankCount','bank')
			end
			setResult(id,res)
		end
		for name,b in pairs(res) do
			local dname, drealm = strsplit(" - ",name)
			if(isCurrency) then
				tooltip:AddLine(format("%s %s: %s",getIcon(id),dname,b))
			else
				local input = {}
				local sum = 0
				if(b['count'] and b['count']>0) then
					input[#input+1] = format("Bags %s",b['count'])
					sum = sum + b['count']					
				end
				if(b['bankCount'] and b['bankCount']>0) then
					input[#input+1] = format("Bank %s",b['bankCount'])
					sum = sum + b['bankCount']					
				end
				if(b['reagentCount'] and b['reagentCount']>0) then
					input[#input+1] = format("Reagents %s",b['reagentCount'])
					sum = sum + b['reagentCount']
				end
				tooltip:AddLine(format("%s %s: %s [ %s ] ",getIcon(id),dname,sum,colorize(table.concat(input,', '),"ffffff")))
				input = nil
			end
		end
		res = nil
		if(checkGID()) then
			local gres = gbagLoop({},id,'gbCount','guildbank')
			for name, b in pairs(gres) do
				tooltip:AddLine(format("%s %s: %s",getIcon(id),name,colorize(b['gbCount'],"ffffff")))
			end
			gres = nil
		end
--		tooltip:AddLine(format("Id: %i",id))
	end
end
local function SetCurrencyByID(tooltip,itemID)
	if(itemID) then
		local res = getResult(itemID)
		if(not res) then
			res = curLoop({},itemID)
		end
		if(res) then
			tooltip:AddLine(" ")
			for name, b in pairs(res) do
				tooltip:AddLine(format("%s %s: %s",getIcon(itemID),name,b))
			end
		end
	end
	tooltip:Show()
	return tooltip,itemID
end
local function SetCurrencyToken(tooltip,index)
	SetCurrencyByID(tooltip,getCurrencyItem(index))
end
local function GameTooltip_SetHyperlink(tooltip, link)
	SetCurrencyByID(tooltip,link:match("currency:(%d+)"))
end
GameTooltip:HookScript("OnTooltipSetItem", GameTooltip_OnTooltipSetItem)
hooksecurefunc(GameTooltip,"SetHyperlink", GameTooltip_SetHyperlink)
hooksecurefunc(GameTooltip, "SetCurrencyByID", SetCurrencyByID)
hooksecurefunc(GameTooltip, "SetCurrencyToken", SetCurrencyToken)
local function scanBag(bag)
	local slot = 1
	local itemlist = {}
	local empty = true
	while(slot<=GetContainerNumSlots(bag)) do
		local texture, itemCount, locked, quality, readable, lootable, itemLink, isFiltered = GetContainerItemInfo(bag, slot)
		if(itemLink) then
			local id = getItemId(itemLink)
			if(id) then
				empty = false
				if(getResult(id)) then
					setResult(id,nil)
				end
				itemlist[id] = itemlist[id] or {}
				itemlist[id]['count'] = itemlist[id]['count'] or 0
				itemlist[id]['count'] = itemlist[id]['count'] + itemCount
				if(not ns['db']['profile']['names'][id]) then
					setName(id,GetItemInfo(id))
				end
			end
		end
		slot = slot + 1
	end
	return empty and nil or itemlist
end

local function funcSync(func,delayed)
	local st = GetTime()
	if(delayed and sync[func]['times'][delayed]) then
		sync[func]['times'][delayed] = nil
	end
	sync[func] = sync[func] or {
		['last'] = 0,
		['times'] = {}
	}
	if(not (st == sync[func]['last'])) then
		sync[func]['last'] = st
		return true
	else
		if(not sync[func]['times'][st]) then
			sync[func]['times'][st] = true
			C_Timer.After(.1, function() func(st) end)
		end
		return
	end	
end
local function scanAllBankBags(delayed)
	if(not BankIsOpen) then return end
	if(not funcSync(scanAllBankBags,delayed)) then return end
	for bag=5,GetNumBankSlots()+4 do
		ns['db']['profile']['bank'][playerID][bag] = scanBag(bag) -- loop all bought bankbags
	end
	ns['db']['profile']['bank'][playerID][-1] = scanBag(-1) -- Main bankbag
	ns['db']['profile']['bank'][playerID][-3] = scanBag(-3) -- Main reagentbag
	for k,v in pairs(ns['db']['profile']['bank'][playerID]) do
		if(not(k==-1) and not(k==-3) and not(k>4 and k<=GetNumBankSlots()+4)) then
			ns['db']['profile']['bank'][playerID][k] = nil -- prevent bogus bankbags
		end
	end
end
local function scanAllBags(delayed)
	if(not funcSync(scanAllBags,delayed)) then return end
	for bag=0,4 do
		ns['db']['profile']['bags'][playerID][bag] = scanBag(bag) -- loop all bought bags
	end
	for k,v in pairs(ns['db']['profile']['bags'][playerID]) do
		if(k<0 or k>4) then
			ns['db']['profile']['bags'][playerID][k] = nil -- prevent bogus bags
		end
	end
end
local function scanGuildBank(tab)
	local itemlist = {}
	local empty = true
	for slot = 1,14*7 do
		local texturePath, itemCount, locked, isFiltered = GetGuildBankItemInfo(tab,slot)
		if(itemCount>0) then
			emtpy = false
			local itemLink = GetGuildBankItemLink(tab,slot)
			if(itemLink) then
				local id = getItemId(itemLink)
				if(id) then
					empty = false
					if(getResult(id)) then
						setResult(id,nil)
					end
					itemlist[id] = itemlist[id] or {}
					itemlist[id]['count'] = itemlist[id]['count'] or 0
					itemlist[id]['count'] = itemlist[id]['count'] + itemCount
					if(not ns['db']['profile']['names'][id]) then
						setName(id,GetItemInfo(id))
					end
				end
			end
		end
	end
	return empty and nil or itemlist
end
ns['frame']['GET_ITEM_INFO_RECEIVED'] = function(self, id)
	if(not ns['db']['profile']['names'][id]) then
		setName(id,GetItemInfo(id))
	end
end
ns['frame']['CURRENCY_DISPLAY_UPDATE'] = function()
	if(not checkPID()) then return end
	updateCurrencies(playerID)
end
ns['frame']['GUI'] = function(self, event)
	BankIsOpen = false
end
ns['frame']['BANKFRAME_OPENED'] = function(self, event)
	BankIsOpen = true
	if(not checkPID()) then return end
	scanAllBankBags(nil)
end
ns['frame']['GUILDBANKFRAME_CLOSED'] = function(self, event)
	GuildBankIsOpen = false
end
ns['frame']['GUILDBANKFRAME_OPENED'] = function(self, event)
	GuildBankIsOpen = true
end
ns['frame']['GUILDBANKBAGSLOTS_CHANGED'] = function(self, event)
	if(not checkGID() or not GuildBankIsOpen) then return end
	local tab = GetCurrentGuildBankTab()
	if(tab>0) then
		local list = scanGuildBank(tab)
		if(list and guildID) then
			ns['db']['profile']['guildbank'][guildID][tab] = list
		end
	end
end
ns['frame']['PLAYERBANKBAGSLOTS_CHANGED'] = ns['frame']['BANKFRAME_OPENED']
ns['frame']['PLAYERBANKSLOTS_CHANGED'] = ns['frame']['BANKFRAME_OPENED']
ns['frame']['PLAYERREAGENTBANKSLOTS_CHANGED'] = ns['frame']['BANKFRAME_OPENED']
ns['frame']['BAG_UPDATE'] = function(self, event, bag)
	if(not checkPID()) then return end
	ns['db']['profile']['bags'][playerID][bag] = scanBag(bag)
end
ns['frame']['ITEM_LOCK_CHANGED'] = function(self, event, bag)
	if(not checkPID()) then return end
	scanAllBags(nil)
	scanAllBankBags(nil)
end
ns['frame']['BAG_UPDATE_DELAYED'] = ns['frame']['ITEM_LOCK_CHANGED']
ns['frame']['ITEM_UNLOCKED'] = ns['frame']['ITEM_LOCK_CHANGED']
local function pout(msg)
	SELECTED_CHAT_FRAME:AddMessage(tostring(msg))
end
SlashCmdList[string.upper(name)] = function(msg)
	local um = string.upper(msg)
	for id, itemname in pairs(ns['db']['profile']['names']) do
		local un = string.upper(itemname)
		if(string.find(un,um)) then
			local _,itemlink = GetItemInfo(id)
			local dout = {}
			if(id)then
				local res = getResult(id)
				if(not res) then
					res = bagLoop({},id,'count','bags')
					res = bagLoop(res,id,'bankCount','bank')
					setResult(id,res)
				end
				for name,b in pairs(res) do
					local dname, drealm = strsplit(" - ",name)
					local input = {}
					local sum = 0
					if(b['count'] and b['count']>0) then
						input[#input+1] = format("Bags %s",b['count'])
						sum = sum + b['count']					
					end
					if(b['bankCount'] and b['bankCount']>0) then
						input[#input+1] = format("Bank %s",b['bankCount'])
						sum = sum + b['bankCount']					
					end
					if(b['reagentCount'] and b['reagentCount']>0) then
						input[#input+1] = format("Reagents %s",b['reagentCount'])
						sum = sum + b['reagentCount']
					end
					dout[#dout+1] = (format(" %s: %s [ %s ] ",dname,sum,colorize(table.concat(input,', '),"ffffff")))
					input = nil
				end
				res = nil
				if(checkGID()) then
					local gres = gbagLoop({},id,'gbCount','guildbank')
					for name, b in pairs(gres) do
						dout[#dout+1] = (format(" %s: %s",colorize(name,"00ffff"),colorize(b['gbCount'],"ffffff")))
					end
					gres = nil
				end
			end
			if(#dout>0) then
				pout(format("%s %s",getIcon(id),itemlink and itemlink or itemname))
				for k,v in pairs(dout) do
					pout(v)
				end
			end
		end
	end
end
_G["SLASH_"..string.upper(name).."1"] = "/find"